#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=prog.ico
#AutoIt3Wrapper_outfile=TSAdress.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=TSAdress
#AutoIt3Wrapper_Res_Fileversion=1.5.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>
#include <Constants.au3>
#include <Crypt.au3>
#include <DateTimeConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <StructureConstants.au3>
#include <Timers.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)
Opt('TrayOnEventMode', 1)
Opt('TrayMenuMode', 1)
Opt('WinTitleMatchMode', 4)

Global $sVersion = '1.5.0.0'
Global $sDate = '21.03.2010'
Global $sTitle = 'TSAdress'
_Singleton($sTitle)
TCPStartup()

Global $sAppDir = @ScriptDir & '\'
Global $fMobile = False
If FileExists($sAppDir & 'TSAdress.ini') And @Compiled Then $fMobile = Execute(IniRead($sAppDir & 'TSAdress.ini', 'Config', 'Mobile', False))
If Not $fMobile Then Global $sAppDir = @AppDataDir & '\TSAdress\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'TSAdress.ini'

Global $fAutostart = Not Execute(IniRead($sInifile, 'Config', 'Autostart', False))
Global $fStartMini = Not Execute(IniRead($sInifile, 'Config', 'StartMini', False))
Global $fSaveOnExit = Not Execute(IniRead($sInifile, 'Config', 'SaveOnExit', True))

Global $sFritzBoxIP, $sFritzBoxPort = 1012, $hFritzSocket
Global $fFritzBoxExists = Execute(IniRead($sInifile, 'Config', 'FritzBoxExists', False))
If $fFritzBoxExists Then
	$sFritzBoxIP = TCPNameToIP('fritz.box')
	If @error Then $fFritzBoxExists = False
EndIf

Global $aTaskbarPos = WinGetPos('classname=Shell_TrayWnd')
Global $iWidth = 360
Global $iHeight = 500
Global $iLeft = $aTaskbarPos[2] - $iWidth - 12
Global $iTop = $aTaskbarPos[1] - $iHeight - 33
Global $aStatusParts[2] = [Int($iWidth / 2), Int($iWidth / 2)]
Global $aAdressbook[1][16], $iEntryCount = 0, $sChecksum, $iEditItem
Global $iLV1stColor = IniRead($sInifile, 'Config', '1stColor', '')
Global $iLV2ndColor = IniRead($sInifile, 'Config', '2ndColor', '')
If $iLV1stColor = '' Then
	$iLV1stColor = 0xF3D6B3
	IniWrite($sInifile, 'Config', '1stColor', '0x' & Hex($iLV1stColor, 6))
EndIf
If $iLV2ndColor = '' Then
	$iLV2ndColor = 0xF3D6B3
	IniWrite($sInifile, 'Config', '2ndColor', '0x' & Hex($iLV2ndColor, 6))
EndIf

TraySetIcon(@ScriptDir & '\prog.ico', -1)
TraySetClick(8)
TraySetToolTip($sTitle)
TraySetOnEvent($TRAY_EVENT_PRIMARYDOUBLE, '_ShowMainGui')
TrayCreateItem($sTitle & '   (v' & StringLeft($sVersion, 3) & ')')
TrayItemSetState(-1, $TRAY_DISABLE)
TrayCreateItem('')
$hTraySaveDB = TrayCreateItem(' ')
TrayItemSetOnEvent(-1, '_SaveAdressbook')
TrayItemSetState(-1, $TRAY_DISABLE)
TrayCreateItem('')
TrayCreateItem('Programm beenden')
TrayItemSetOnEvent(-1, '_End')

$hGui = GUICreate($sTitle, $iWidth, $iHeight, $iLeft, $iTop, BitOR($WS_SYSMENU, $WS_CAPTION))
GUISetOnEvent($GUI_EVENT_CLOSE, '_ShowMainGui')
;~ GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_ShowMainGui')
GUISetIcon(@ScriptDir & '\prog.ico', -1)
GUISetBkColor(0xBBBBBB)

$hMenuFile = GUICtrlCreateMenu('Datei')
GUICtrlCreateMenuItem('Adressbuch laden', $hMenuFile)
GUICtrlSetOnEvent(-1, '_LoadAdressbook')
GUICtrlCreateMenuItem('Adressbuch speichern', $hMenuFile)
GUICtrlSetOnEvent(-1, '_SaveAdressbook')
GUICtrlCreateMenuItem('', $hMenuFile)
GUICtrlCreateMenuItem('Backup erstellen', $hMenuFile)
GUICtrlSetOnEvent(-1, '_SaveBackup')
GUICtrlCreateMenuItem('Backup laden', $hMenuFile)
GUICtrlSetOnEvent(-1, '_LoadBackup')
GUICtrlCreateMenuItem('', $hMenuFile)
GUICtrlCreateMenuItem('Programm beenden', $hMenuFile)
GUICtrlSetOnEvent(-1, '_End')

$hMenuEdit = GUICtrlCreateMenu('Bearbeiten')
GUICtrlCreateMenuItem('&Neuer Eintrag', $hMenuEdit)
GUICtrlSetOnEvent(-1, '_NewEntry')
GUICtrlCreateMenuItem('Markierte Eintrge &lschen', $hMenuEdit)
GUICtrlSetOnEvent(-1, '_DelMarkEntry')

$hMenuConfig = GUICtrlCreateMenu('Einstellungen')
$hMenuConfigMini = GUICtrlCreateMenuItem('Minimiert starten', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SetStartMini')
$hMenuConfigAS = GUICtrlCreateMenuItem('Windows-Autostart', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SetAutostart')
$hMenuConfigSave = GUICtrlCreateMenuItem('Adressbuch bei Programmende speichern', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SetSaveOnExit')
$hMenuConfigFritzBox = GUICtrlCreateMenuItem('FritzBox-Anrufmonitor aktivieren', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SetFritzBox')
$hMenuConfigMobile = GUICtrlCreateMenuItem('Daten im Programmverzeichnis speichern (Mobile-Version)', $hMenuConfig)
GUICtrlSetOnEvent(-1, '_SetMobile')

$hMenuHelp = GUICtrlCreateMenu('Hilfe')
GUICtrlCreateMenuItem('FritzBox-Anrufmonitor', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_FritzBoxInfo')
GUICtrlCreateMenuItem('Programm-Info', $hMenuHelp)
GUICtrlSetOnEvent(-1, '_ProgInfo')

GUICtrlCreateLabel('Suchbegriff:', 8, 5, 100, 15)
$hSearch = GUICtrlCreateInput('', 4, 20, $iWidth - 8, 20)

Global $iExStyle = $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT + $LVS_EX_DOUBLEBUFFER
$hAdressLV = GUICtrlCreateListView('Name|Vorname|Telefon', 4, 44, $iWidth - 8, $iHeight - 90, $LVS_SHOWSELALWAYS, $iExStyle)
GUICtrlSendMsg($hAdressLV, $LVM_SETCOLUMNWIDTH, 0, Int(($iWidth - 40) / 3))
GUICtrlSendMsg($hAdressLV, $LVM_SETCOLUMNWIDTH, 1, Int(($iWidth - 40) / 3))
GUICtrlSendMsg($hAdressLV, $LVM_SETCOLUMNWIDTH, 2, Int(($iWidth - 30) / 3))
GUICtrlSetBkColor($hAdressLV, $iLV1stColor)
GUICtrlSetBkColor($hAdressLV, $GUI_BKCOLOR_LV_ALTERNATE)
$hWndAdressLV = GUICtrlGetHandle($hAdressLV)

$hLVContext = GUICtrlCreateContextMenu($hAdressLV)
$hLVContextNew = GUICtrlCreateMenuItem('&Neuer Eintrag', $hLVContext)
GUICtrlSetOnEvent(-1, '_NewEntry')
$hLVContextEdit = GUICtrlCreateMenuItem('Eintrag &bearbeiten', $hLVContext)
GUICtrlSetOnEvent(-1, '_ContextEdit')
$hLVContextDel = GUICtrlCreateMenuItem('Markierte Eintrge &lschen', $hLVContext)
GUICtrlSetOnEvent(-1, '_DelMarkEntry')
Global $aAccelKeys[3][2] = [['!n', $hLVContextNew],['!b', $hLVContextEdit],['!l', $hLVContextDel]]

$hStatus = _GUICtrlStatusBar_Create($hGui, $aStatusParts)
_GUICtrlStatusBar_SetText($hStatus, 'Bereit.', 0)
_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(221))
_GUICtrlStatusBar_SetText($hStatus, '0 Eintrge', 1)
_GUICtrlStatusBar_SetIcon($hStatus, 1, _WinAPI_LoadShell32Icon(160))

If Not @Compiled Then GUICtrlSetState($hMenuConfigMobile, $GUI_DISABLE)
If $fMobile Then
	GUICtrlSetState($hMenuConfigMobile, $GUI_CHECKED)
	GUICtrlSetState($hMenuConfigAS, $GUI_DISABLE)
Else
	_SetAutostart()
EndIf
_SetStartMini()
_SetSaveOnExit()
_LoadAdressbook()
If $fFritzBoxExists Then
	TrayTip($sTitle, 'Verbinde mit FritzBox...', 5, 1)
	$hFritzSocket = TCPConnect($sFritzBoxIP, $sFritzBoxPort)
	If $hFritzSocket = -1 Then
		TrayTip($sTitle, 'Verbindungsfehler! Anrufmonitor nicht verfgbar!', 5, 3)
		$fFritzBoxExists = False
	Else
		GUICtrlSetState($hMenuConfigFritzBox, $GUI_CHECKED)
		TrayTip($sTitle, 'Verbindung hergestellt! Anrufmonitor aktiv!', 5, 1)
	EndIf
EndIf

GUISetAccelerators($aAccelKeys)
If Not $fStartMini Then GUISetState(@SW_SHOW, $hGui)
WinSetOnTop($hGui, '', 1)

Global $ahInput[11], $ahInputTelNr[4], $ahRadioTelNr[4], $iInputColor = 0x0000BB, $ahInputOk[4]

$hInputGui = GUICreate($sTitle & ' - Neueintrag', 410, 550, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION), Default, $hGui)
GUISetIcon(@ScriptDir & '\prog.ico', -1)
GUISetBkColor(0xBBBBBB)
GUISetFont(9, 400, 0, 'Times New Roman', $hInputGui)
GUISetOnEvent($GUI_EVENT_CLOSE, '_HideInputGui')

GUICtrlCreateLabel('Nachname', 15, 15, 100, 15)
$ahInput[0] = GUICtrlCreateInput('', 10, 30, 190, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('Vorname', 215, 15, 100, 15)
$ahInput[1] = GUICtrlCreateInput('', 210, 30, 190, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)

GUICtrlCreateGroup('Telefonnummern (Auswahl = Anzeige in der Liste)', 10, 60, 390, 140)
$ahRadioTelNr[0] = GUICtrlCreateRadio('Telefon (privat)', 20, 80, 130, 20)
GUICtrlSetState(-1, $GUI_CHECKED)
$ahInputTelNr[0] = GUICtrlCreateInput('', 150, 80, 240, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)
$ahRadioTelNr[1] = GUICtrlCreateRadio('Handy (privat)', 20, 110, 130, 20)
$ahInputTelNr[1] = GUICtrlCreateInput('', 150, 110, 240, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)
$ahRadioTelNr[2] = GUICtrlCreateRadio('Telefon (geschftl.)', 20, 140, 130, 20)
$ahInputTelNr[2] = GUICtrlCreateInput('', 150, 140, 240, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)
$ahRadioTelNr[3] = GUICtrlCreateRadio('Handy (geschftl.)', 20, 170, 130, 20)
$ahInputTelNr[3] = GUICtrlCreateInput('', 150, 170, 240, 20)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Adresse', 10, 210, 390, 140)
GUICtrlCreateLabel('Strasse, Hausnummer', 30, 233, 110, 20)
$ahInput[2] = GUICtrlCreateInput('', 150, 230, 240, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('Zusatzinformation', 30, 263, 110, 20)
$ahInput[3] = GUICtrlCreateInput('', 150, 260, 240, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('PLZ', 30, 293, 30, 20)
$ahInput[4] = GUICtrlCreateInput('', 60, 290, 55, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('Ort', 125, 293, 25, 20)
$ahInput[5] = GUICtrlCreateInput('', 150, 290, 240, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('Land/Staat', 30, 323, 90, 20)
$ahInput[6] = GUICtrlCreateInput('', 150, 320, 240, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Sonstiges', 10, 360, 390, 140)
GUICtrlCreateLabel('Geburtstag', 30, 383, 70, 20)
$ahInput[7] = GUICtrlCreateDate('', 170, 380, 120, 20, $DTS_SHORTDATEFORMAT)
GUICtrlSetFont(-1, 11, 400)
GUICtrlSetOnEvent(-1, '_ChangeDate')
GUICtrlCreateLabel('EMail (privat)', 30, 413, 90, 20)
$hInputSend1 = GUICtrlCreateButton('EMail', 125, 410, 40, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_SendEMail')
$ahInput[8] = GUICtrlCreateInput('', 170, 410, 220, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('EMail (geschftl.)', 30, 443, 90, 20)
$hInputSend2 = GUICtrlCreateButton('EMail', 125, 440, 40, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_SendEMail')
$ahInput[9] = GUICtrlCreateInput('', 170, 440, 220, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateLabel('Homepage', 30, 473, 90, 20)
$hInputKlick = GUICtrlCreateButton('Klick', 125, 470, 40, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StartBrowser')
$ahInput[10] = GUICtrlCreateInput('', 170, 470, 220, 20)
GUICtrlSetFont(-1, 10, 400)
GUICtrlSetColor(-1, $iInputColor)
GUICtrlCreateGroup('', -99, -99, 1, 1)

$ahInputOk[0] = GUICtrlCreateButton('Eingaben lschen', 10, 510, 120, 25)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_NewEntry')
$ahInputOk[1] = GUICtrlCreateButton('Ok', 170, 510, 50, 25)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_ApplyNewEntry')
GUICtrlSetState(-1, $GUI_DISABLE)
$ahInputOk[2] = GUICtrlCreateButton('bernehmen', 225, 510, 90, 25)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_ApplyNewEntry')
GUICtrlSetState(-1, $GUI_DISABLE)
$ahInputOk[3] = GUICtrlCreateButton('Abbrechen', 320, 510, 80, 25)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_HideInputGui')

GUIRegisterMsg($WM_COMMAND, '_WM_COMMAND')
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
GUICtrlSetState($hAdressLV, $GUI_FOCUS)

Global $aInfo, $sTooltip, $iHotItem = -1, $sFritzRecv
While Sleep(50)
	If _Timer_GetIdleTime() > 500 Then
		$aInfo = GUIGetCursorInfo($hGui)
		If $aInfo[4] = $hAdressLV And $iHotItem = -1 Then
			$iHotItem = _GUICtrlListView_GetHotItem($hWndAdressLV)
			If $iHotItem > -1 Then
				$sTooltip = $aAdressbook[$iHotItem][1] & ' ' & $aAdressbook[$iHotItem][0] & @CRLF
				If $aAdressbook[$iHotItem][2] <> '' Then $sTooltip &= $aAdressbook[$iHotItem][2] & @CRLF
				If $aAdressbook[$iHotItem][3] <> '' Then $sTooltip &= $aAdressbook[$iHotItem][3] & @CRLF
				If $aAdressbook[$iHotItem][4] <> '' Then $sTooltip &= $aAdressbook[$iHotItem][4] & ' ' & $aAdressbook[$iHotItem][5] & @CRLF
				For $i = 11 To 14
					If $aAdressbook[$iHotItem][$i] <> '' Then $sTooltip &= $aAdressbook[$iHotItem][$i] & @CRLF
				Next
				ToolTip($sTooltip, MouseGetPos(0), MouseGetPos(1), 'Kurzinfo', 1, 7)
			EndIf
		EndIf
	Else
		$iHotItem = -1
		ToolTip('')
	EndIf
	If $fFritzBoxExists Then
		$sFritzRecv = TCPRecv($hFritzSocket, 2048)
		If $sFritzRecv <> '' Then _TelRing($sFritzRecv)
	EndIf
WEnd

Func _TelRing($sRecv)
	Local $aMsg, $sAnrufer = 'Unbekannter Anrufer'
	$aMsg = StringSplit($sRecv, ';')
	If Not IsArray($aMsg) Then Return
	If $aMsg[0] < 5 Then Return
	Switch $aMsg[2]
		Case 'RING'
			If $aMsg[4] <> '' Then
				For $i = 0 To UBound($aAdressbook) - 1
					For $j = 11 To 15
						If $aMsg[4] = StringRegExpReplace($aAdressbook[$i][$j], '\D', '') Then
							$sAnrufer = $aAdressbook[$i][1] & ' ' & $aAdressbook[$i][0]
							ExitLoop 2
						EndIf
					Next
				Next
			EndIf
			FileWriteLine($sAppDir & 'Anrufliste.txt', $aMsg[1] & '   Tel.-Nr.: ' & $aMsg[4] & ' -> ' & $sAnrufer)
			TrayTip('Anruf', $sAnrufer & @CRLF & $aMsg[4], 30, 1)
		Case 'DISCONNECT'
			TrayTip('', '', 0)
	EndSwitch
EndFunc   ;==>_TelRing

Func _WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	Local $nID = BitAND($wParam, 0x0000FFFF), $iFound
	Switch $hWnd
		Case $hGui
			If $nID = $hSearch Then
				$iFound = _GUICtrlListView_FindInText($hWndAdressLV, GUICtrlRead($hSearch))
				If $iFound <> -1 Then
					_GUICtrlListView_SetItemSelected($hWndAdressLV, -1, False)
					_GUICtrlListView_EnsureVisible($hWndAdressLV, $iFound)
					_GUICtrlListView_SetItemSelected($hWndAdressLV, $iFound, True)
				Else
					_GUICtrlListView_EnsureVisible($hWndAdressLV, 0)
					_GUICtrlListView_SetItemSelected($hWndAdressLV, -1, False)
				EndIf
			EndIf
		Case $hInputGui
			Switch $nID
				Case $ahInputOk[0], $ahInputOk[1], $ahInputOk[2], $ahInputOk[3]
					; nothing to do ;-)
				Case Else
					_CheckEnableButton()
					If $sChecksum <> _GenChecksum() Then
						If BitAND(GUICtrlGetState($ahInputOk[1]), $GUI_DISABLE) Then
							GUICtrlSetState($ahInputOk[1], $GUI_ENABLE)
							GUICtrlSetState($ahInputOk[2], $GUI_ENABLE)
						EndIf
					Else
						If BitAND(GUICtrlGetState($ahInputOk[1]), $GUI_ENABLE) Then
							GUICtrlSetState($ahInputOk[1], $GUI_DISABLE)
							GUICtrlSetState($ahInputOk[2], $GUI_DISABLE)
						EndIf
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_COMMAND

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	Local $hWndFrom, $iCode, $tNMHDR
	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	$iCode = DllStructGetData($tNMHDR, 'Code')
	Switch $hWndFrom
		Case $hWndAdressLV
			Switch $iCode
				Case $NM_DBLCLK
					$iEditItem = ControlListView($hGui, '', $hAdressLV, 'GetSelected')
					If $iEditItem <> '' Then _EditEntry()
					Return 0
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _End()
	TCPShutdown()
	If $fSaveOnExit Then _SaveAdressbook()
	Exit
EndFunc   ;==>_End

Func _ContextEdit()
	$iEditItem = ControlListView($hGui, '', $hAdressLV, 'GetSelected')
	If $iEditItem <> '' Then _EditEntry()
EndFunc   ;==>_ContextEdit

Func _ShowMainGui()
	Switch BitAND(WinGetState($hGui), 2)
		Case True
			GUISetState(@SW_HIDE, $hGui)
		Case False
			GUISetState(@SW_SHOW, $hGui)
	EndSwitch
EndFunc   ;==>_ShowMainGui

Func _ChangeDate()
	If $sChecksum <> _GenChecksum() Then
		If BitAND(GUICtrlGetState($ahInputOk[1]), $GUI_DISABLE) Then
			GUICtrlSetState($ahInputOk[1], $GUI_ENABLE)
			GUICtrlSetState($ahInputOk[2], $GUI_ENABLE)
		EndIf
	Else
		If BitAND(GUICtrlGetState($ahInputOk[1]), $GUI_ENABLE) Then
			GUICtrlSetState($ahInputOk[1], $GUI_DISABLE)
			GUICtrlSetState($ahInputOk[2], $GUI_DISABLE)
		EndIf
	EndIf
EndFunc   ;==>_ChangeDate

Func _EditEntry()
	WinSetTitle($hInputGui, '', $sTitle & ' - Bearbeiten')
	For $i = 0 To 10
		GUICtrlSetData($ahInput[$i], $aAdressbook[$iEditItem][$i])
	Next
	For $i = 0 To 3
		GUICtrlSetData($ahInputTelNr[$i], $aAdressbook[$iEditItem][$i + 11])
		GUICtrlSetState($ahRadioTelNr[$i], $GUI_UNCHECKED)
	Next
	GUICtrlSetState($ahRadioTelNr[$aAdressbook[$iEditItem][15]], $GUI_CHECKED)
	GUICtrlSetState($hInputSend1, $GUI_DISABLE)
	GUICtrlSetState($hInputSend2, $GUI_DISABLE)
	GUICtrlSetState($hInputKlick, $GUI_DISABLE)
	GUICtrlSetState($ahInputOk[1], $GUI_DISABLE)
	GUICtrlSetState($ahInputOk[2], $GUI_DISABLE)
	GUICtrlSetOnEvent($ahInputOk[1], '_ApplyEditEntry')
	GUICtrlSetOnEvent($ahInputOk[2], '_ApplyEditEntry')
	_CheckEnableButton()
	$sChecksum = _GenChecksum()
	GUISetBkColor(0xBBBBBB, $hInputGui)
	GUISetState(@SW_SHOW, $hInputGui)
EndFunc   ;==>_EditEntry

Func _ApplyEditEntry()
	For $i = 0 To 10
		If $i = 7 Then
			$aAdressbook[$iEditItem][$i] = StringRegExpReplace(GUICtrlRead($ahInput[$i]), '(\d{2})\.(\d{2})\.(\d{4})', '$3/$2/$1 00:00:00')
		Else
			$aAdressbook[$iEditItem][$i] = GUICtrlRead($ahInput[$i])
		EndIf
	Next
	For $i = 0 To 3
		$aAdressbook[$iEditItem][$i + 11] = GUICtrlRead($ahInputTelNr[$i])
		If BitAND(GUICtrlRead($ahRadioTelNr[$i]), $GUI_CHECKED) Then $aAdressbook[$iEditItem][15] = $i
	Next
	_DisplayListview()
	_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(77))
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gendert!', 0)
	TrayItemSetText($hTraySaveDB, 'Adressbuch gendert! Jetzt speichern...')
	TrayItemSetState($hTraySaveDB, BitOR($TRAY_ENABLE, $TRAY_UNCHECKED))
	TraySetIcon('shell32.dll', -78)
	If @GUI_CtrlId = $ahInputOk[1] Then Return _HideInputGui()
	_EditEntry()
EndFunc   ;==>_ApplyEditEntry

Func _NewEntry()
	Local $iStart = 0
	If $iEditItem <> '' Then $iStart = 2
	WinSetTitle($hInputGui, '', $sTitle & ' - Neueintrag')
	For $i = $iStart To UBound($ahInput) - 1
		GUICtrlSetData($ahInput[$i], '')
	Next
	For $i = 0 To UBound($ahInputTelNr) - 1
		GUICtrlSetData($ahInputTelNr[$i], '')
	Next
	For $i = 1 To UBound($ahRadioTelNr) - 1
		GUICtrlSetState($ahRadioTelNr[$i], $GUI_UNCHECKED)
	Next
	GUICtrlSetState($ahRadioTelNr[0], $GUI_CHECKED)
	GUICtrlSetState($hInputSend1, $GUI_DISABLE)
	GUICtrlSetState($hInputSend2, $GUI_DISABLE)
	GUICtrlSetState($hInputKlick, $GUI_DISABLE)
	GUICtrlSetState($ahInputOk[1], $GUI_DISABLE)
	GUICtrlSetState($ahInputOk[2], $GUI_DISABLE)
	GUICtrlSetOnEvent($ahInputOk[1], '_ApplyNewEntry')
	GUICtrlSetOnEvent($ahInputOk[2], '_ApplyNewEntry')
	_CheckEnableButton()
	$sChecksum = _GenChecksum()
	GUISetBkColor(0xBBBBBB, $hInputGui)
	GUISetState(@SW_SHOW, $hInputGui)
	GUICtrlSetState($ahInput[0], $GUI_FOCUS)
EndFunc   ;==>_NewEntry

Func _ApplyNewEntry()
	If Not IsArray($aAdressbook) Then
		Dim $aAdressbook[1][16]
	Else
		ReDim $aAdressbook[$iEntryCount + 1][16]
	EndIf
	For $i = 0 To 10
		If $i = 7 Then
			$aAdressbook[$iEntryCount][$i] = StringRegExpReplace(GUICtrlRead($ahInput[$i]), '(\d{2})\.(\d{2})\.(\d{4})', '$3/$2/$1 00:00:00')
		Else
			$aAdressbook[$iEntryCount][$i] = GUICtrlRead($ahInput[$i])
		EndIf
	Next
	For $i = 0 To 3
		$aAdressbook[$iEntryCount][$i + 11] = GUICtrlRead($ahInputTelNr[$i])
		If BitAND(GUICtrlRead($ahRadioTelNr[$i]), $GUI_CHECKED) Then $aAdressbook[$iEntryCount][15] = $i
	Next
	$iEntryCount += 1
	_DisplayListview()
	_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(77))
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gendert!', 0)
	TrayItemSetText($hTraySaveDB, 'Adressbuch gendert! Jetzt speichern...')
	TrayItemSetState($hTraySaveDB, BitOR($TRAY_ENABLE, $TRAY_UNCHECKED))
	TraySetIcon('shell32.dll', -78)
	If @GUI_CtrlId = $ahInputOk[1] Then Return _HideInputGui()
	_NewEntry()
EndFunc   ;==>_ApplyNewEntry

Func _CheckEnableButton()
	Local $aCheck[2] = [$GUI_DISABLE, $GUI_ENABLE]
	GUICtrlSetState($hInputSend1, $aCheck[GUICtrlRead($ahInput[8]) <> ''])
	GUICtrlSetState($hInputSend2, $aCheck[GUICtrlRead($ahInput[9]) <> ''])
	GUICtrlSetState($hInputKlick, $aCheck[GUICtrlRead($ahInput[10]) <> ''])
EndFunc   ;==>_CheckEnableButton

Func _HideInputGui()
	GUISetState(@SW_HIDE, $hInputGui)
	$iEditItem = ''
EndFunc   ;==>_HideInputGui

Func _GenChecksum()
	Local $sItem, $sSum
	For $i = 0 To 10
		If $i = 7 Then
			$sItem &= StringRegExpReplace(GUICtrlRead($ahInput[$i]), '(\d{2})\.(\d{2})\.(\d{4})', '$3/$2/$1 00:00:00')
		Else
			$sItem &= GUICtrlRead($ahInput[$i])
		EndIf
	Next
	For $i = 0 To 3
		$sItem &= GUICtrlRead($ahInputTelNr[$i])
		If BitAND(GUICtrlRead($ahRadioTelNr[$i]), $GUI_CHECKED) Then $sItem &= $i
	Next
	$sSum = _Crypt_HashData($sItem, $CALG_MD5)
	Return $sSum
EndFunc   ;==>_GenChecksum

Func _DisplayListview()
	Local $iTel, $sItem
	_NewArraySort($aAdressbook, 0, 1)
	_GUICtrlListView_DeleteAllItems($hWndAdressLV)
	For $i = 0 To UBound($aAdressbook) - 1
		$iTel = $aAdressbook[$i][15]
		$sItem = $aAdressbook[$i][0] & '|' & $aAdressbook[$i][1]
		$sItem &= '|' & $aAdressbook[$i][11 + $iTel]
		GUICtrlCreateListViewItem($sItem, $hAdressLV)
		GUICtrlSetBkColor(-1, $iLV2ndColor)
	Next
	_GUICtrlStatusBar_SetText($hStatus, UBound($aAdressbook) & ' Eintrge', 1)
EndFunc   ;==>_DisplayListview

Func _DelMarkEntry()
	Local $aDelItems
	$aDelItems = _GUICtrlListView_GetSelectedIndices($hWndAdressLV, True)
	If $aDelItems[0] = 0 Then Return
	If MsgBox(4 + 32 + 256, $sTitle & ' - Lschen', 'Sollen die markierten Eintrge wirklich gelscht werden?', 0, $hGui) <> 6 Then Return
	For $i = $aDelItems[0] To 1 Step -1
		_ArrayDelete($aAdressbook, $aDelItems[$i])
	Next
	_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(77))
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gendert!', 0)
	TrayItemSetText($hTraySaveDB, 'Adressbuch gendert! Jetzt speichern...')
	TrayItemSetState($hTraySaveDB, BitOR($TRAY_ENABLE, $TRAY_UNCHECKED))
	TraySetIcon('shell32.dll', -78)
	$iEntryCount -= $aDelItems[0]
	_GUICtrlStatusBar_SetText($hStatus, UBound($aAdressbook) & ' Eintrge', 1)
	_GUICtrlListView_DeleteItemsSelected($hWndAdressLV)
EndFunc   ;==>_DelMarkEntry

Func _ProgInfo()
	Local $sMsg = 'Version:\t%s\nDatum:\t%s\nAutor:\tOscar (www.autoit.de)\n\n'
	$sMsg &= 'Rechtliches:\n'
	$sMsg &= '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n'
	MsgBox(0, $sTitle & ' - Info', StringFormat($sMsg, $sVersion, $sDate), 0, $hGui)
EndFunc   ;==>_ProgInfo

Func _FritzBoxInfo()
	Local $sMsg = 'Bei der FritzBox gibt es einen eingebauten Anrufmonitor.\n\n'
	$sMsg &= 'Wenn TSAdress keine Verbindung zur FritzBox herstellen kann,\nknnte es daran liegen, dass der TCP-Port 1012 nicht geffnet ist.\n\n'
	$sMsg &= 'Zum ffnen des Ports muss man, an einem an die FritzBox\nangeschlossenen Telefon, folgendes eingeben: #96*5*\n'
	$sMsg &= 'Mit #96*4* wird der Port wieder geschlossen.\n'
	MsgBox(0, $sTitle & ' - FritzBox Info', StringFormat($sMsg, ''), 0, $hGui)
EndFunc   ;==>_FritzBoxInfo

Func _SetAutostart()
	$fAutostart = Not $fAutostart
	Switch $fAutostart
		Case True
			If @Compiled Then FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName)
			GUICtrlSetState($hMenuConfigAS, $GUI_CHECKED)
		Case False
			If @Compiled Then FileDelete(@StartupDir & '\' & @ScriptName & '.lnk')
			GUICtrlSetState($hMenuConfigAS, $GUI_UNCHECKED)
	EndSwitch
	IniWrite($sInifile, 'Config', 'Autostart', $fAutostart)
EndFunc   ;==>_SetAutostart

Func _SetSaveOnExit()
	$fSaveOnExit = Not $fSaveOnExit
	Switch $fSaveOnExit
		Case True
			GUICtrlSetState($hMenuConfigSave, $GUI_CHECKED)
		Case False
			GUICtrlSetState($hMenuConfigSave, $GUI_UNCHECKED)
	EndSwitch
	IniWrite($sInifile, 'Config', 'SaveOnExit', $fSaveOnExit)
EndFunc   ;==>_SetSaveOnExit

Func _SetStartMini()
	$fStartMini = Not $fStartMini
	Switch $fStartMini
		Case True
			GUICtrlSetState($hMenuConfigMini, $GUI_CHECKED)
		Case False
			GUICtrlSetState($hMenuConfigMini, $GUI_UNCHECKED)
	EndSwitch
	IniWrite($sInifile, 'Config', 'StartMini', $fStartMini)
EndFunc   ;==>_SetStartMini

Func _SetFritzBox()
	$fFritzBoxExists = Not $fFritzBoxExists
	Switch $fFritzBoxExists
		Case True
			$sFritzBoxIP = TCPNameToIP('fritz.box')
			If @error Then
				$fFritzBoxExists = False
			Else
				TrayTip($sTitle, 'Verbinde mit FritzBox...', 5, 1)
				$hFritzSocket = TCPConnect($sFritzBoxIP, $sFritzBoxPort)
				If $hFritzSocket = -1 Then
					$fFritzBoxExists = False
					TrayTip($sTitle, 'Verbindungsfehler! Anrufmonitor nicht verfgbar!', 5, 3)
				Else
					TrayTip($sTitle, 'Verbindung hergestellt! Anrufmonitor aktiv!', 5, 1)
					GUICtrlSetState($hMenuConfigFritzBox, $GUI_CHECKED)
				EndIf
			EndIf
		Case False
			GUICtrlSetState($hMenuConfigFritzBox, $GUI_UNCHECKED)
	EndSwitch
	IniWrite($sInifile, 'Config', 'FritzBoxExists', $fFritzBoxExists)
EndFunc   ;==>_SetFritzBox

Func _SetMobile()
	$fMobile = Not $fMobile
	Switch $fMobile
		Case True
			$sAppDir = @ScriptDir & '\'
			$sInifile = $sAppDir & 'TSAdress.ini'
			IniWrite($sAppDir & 'TSAdress.ini', 'Config', 'Mobile', True)
			_SaveAdressbook()
			$fAutostart = True
			_SetAutostart()
			GUICtrlSetState($hMenuConfigAS, $GUI_DISABLE)
			GUICtrlSetState($hMenuConfigMobile, $GUI_CHECKED)
		Case False
			IniWrite($sAppDir & 'TSAdress.ini', 'Config', 'Mobile', False)
			$sAppDir = @AppDataDir & '\TSAdress\'
			$sInifile = $sAppDir & 'TSAdress.ini'
			_SaveAdressbook()
			GUICtrlSetState($hMenuConfigAS, $GUI_ENABLE)
			GUICtrlSetState($hMenuConfigMobile, $GUI_UNCHECKED)
	EndSwitch
	IniWrite($sInifile, 'Config', 'SaveOnExit', $fSaveOnExit)
	IniWrite($sInifile, 'Config', 'StartMini', $fStartMini)
EndFunc   ;==>_SetMobile

Func _LoadAdressbook()
	Local $sFile, $aTmp, $aItem
	If Not FileExists($sAppDir & 'Adressbook.tsa') Then Return _GUICtrlStatusBar_SetText($hStatus, 'Bereit.', 0)
	$sFile = FileRead($sAppDir & 'Adressbook.tsa')
	If @error Then Return _GUICtrlStatusBar_SetText($hStatus, 'Fehler beim laden!', 0)
	$aTmp = StringSplit(StringTrimRight($sFile, 2), @CRLF, 1)
	If Not IsArray($aAdressbook) Then Dim $aAdressbook[1][16]
	ReDim $aAdressbook[$aTmp[0]][16]
	For $i = 1 To $aTmp[0]
		$aItem = StringSplit($aTmp[$i], '|')
		For $j = 1 To $aItem[0]
			$aAdressbook[$i - 1][$j - 1] = $aItem[$j]
		Next
	Next
	_DisplayListview()
	$iEntryCount = UBound($aAdressbook)
	_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(221))
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gespeichert.', 0)
	TrayItemSetText($hTraySaveDB, ' ')
	TrayItemSetState($hTraySaveDB, BitOR($TRAY_DISABLE, $TRAY_UNCHECKED))
	TraySetIcon(@ScriptDir & '\prog.ico', -1)
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch geladen.', 0)
EndFunc   ;==>_LoadAdressbook

Func _SaveAdressbook()
	Local $hFile, $sFile
	If FileExists($sAppDir & 'Adressbook.tsa') Then FileMove($sAppDir & 'Adressbook.tsa', $sAppDir & 'Adressbook.bak', 9)
	$hFile = FileOpen($sAppDir & 'Adressbook.tsa', 2)
	If $hFile <> -1 Then
		For $i = 0 To UBound($aAdressbook) - 1
			For $j = 0 To 15
				$sFile &= $aAdressbook[$i][$j] & '|'
			Next
			$sFile = StringTrimRight($sFile, 1) & @CRLF
		Next
		FileWrite($hFile, $sFile)
		FileClose($hFile)
		_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(221))
		_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gespeichert.', 0)
		TrayItemSetText($hTraySaveDB, ' ')
		TrayItemSetState($hTraySaveDB, BitOR($TRAY_DISABLE, $TRAY_UNCHECKED))
		TraySetIcon(@ScriptDir & '\prog.ico', -1)
		Return
	EndIf
	_GUICtrlStatusBar_SetText($hStatus, 'Fehler beim speichern!', 0)
EndFunc   ;==>_SaveAdressbook

Func _LoadBackup()
	Local $sPath, $sFile, $aTmp, $aItem
	$sPath = FileOpenDialog('Bitte Backup-Datei auswhlen!', $sAppDir, 'TSAdress (*.tsa;*.bak)', 5, '', $hGui)
	If @error Then Return
	$sFile = FileRead($sPath)
	If @error Then Return _GUICtrlStatusBar_SetText($hStatus, 'Fehler beim Backup laden!', 0)
	$aTmp = StringSplit(StringTrimRight($sFile, 2), @CRLF, 1)
	If Not IsArray($aAdressbook) Then Dim $aAdressbook[1][16]
	ReDim $aAdressbook[$aTmp[0]][16]
	For $i = 1 To $aTmp[0]
		$aItem = StringSplit($aTmp[$i], '|')
		For $j = 1 To $aItem[0]
			$aAdressbook[$i - 1][$j - 1] = $aItem[$j]
		Next
	Next
	_DisplayListview()
	$iEntryCount = UBound($aAdressbook)
	_GUICtrlStatusBar_SetIcon($hStatus, 0, _WinAPI_LoadShell32Icon(221))
	_GUICtrlStatusBar_SetText($hStatus, 'Adressbuch gespeichert.', 0)
	TrayItemSetText($hTraySaveDB, ' ')
	TrayItemSetState($hTraySaveDB, BitOR($TRAY_DISABLE, $TRAY_UNCHECKED))
	TraySetIcon(@ScriptDir & '\prog.ico', -1)
	_GUICtrlStatusBar_SetText($hStatus, 'Backup geladen.', 0)
EndFunc   ;==>_LoadBackup

Func _SaveBackup()
	Local $sPath, $hFile, $sFile
	$sPath = FileSaveDialog('Erstelle Backup-Datei', $sAppDir, 'TSAdress (*.bak)', 18, 'Adressbook.bak', $hGui)
	If @error Then Return
	$hFile = FileOpen($sPath, 2)
	If $hFile <> -1 Then
		For $i = 0 To UBound($aAdressbook) - 1
			For $j = 0 To 15
				$sFile &= $aAdressbook[$i][$j] & '|'
			Next
			$sFile = StringTrimRight($sFile, 1) & @CRLF
		Next
		FileWrite($hFile, $sFile)
		FileClose($hFile)
		_GUICtrlStatusBar_SetText($hStatus, 'Backup erstellt.', 0)
		Return
	EndIf
	_GUICtrlStatusBar_SetText($hStatus, 'Fehler beim Backup!', 0)
EndFunc   ;==>_SaveBackup

Func _SendEMail()
	Local $sMailAdress
	Switch @GUI_CtrlId
		Case $hInputSend1
			$sMailAdress = GUICtrlRead($ahInput[8])
		Case $hInputSend2
			$sMailAdress = GUICtrlRead($ahInput[9])
	EndSwitch
	If StringRegExp($sMailAdress, '\S+@\S+') Then
		ShellExecute('mailto:' & $sMailAdress)
	Else
		MsgBox(0, $sTitle & ' - Fehler', 'Keine gltige EMail-Adresse!', 0, $hInputGui)
	EndIf
EndFunc   ;==>_SendEMail

Func _StartBrowser()
	Local $sURL
	$sURL = GUICtrlRead($ahInput[10])
	If StringRegExp($sURL, '\S+') Then
		ShellExecute($sURL)
	Else
		MsgBox(0, $sTitle & ' - Fehler', 'Keine gltige Internetadresse!', 0, $hInputGui)
	EndIf
EndFunc   ;==>_StartBrowser

Func _NewArraySort(ByRef $aSort, $1st, $2nd)
	; Special thanks to UEZ (www.autoit.de) for this function
	Local $j = 0, $k = 1
	_ArraySort($aSort, 0, 0, 0, $1st)
	While $k < UBound($aSort)
		If $aSort[$j][$1st] <> $aSort[$k][$1st] Then
			If $k - $j > 1 Then
				_ArraySort($aSort, 0, $j, $k - 1, $2nd)
				$j = $k
			Else
				$j = $k
			EndIf
		EndIf
		$k += 1
	WEnd
	If $k - $j > 1 Then _ArraySort($aSort, 0, $j, $k, $2nd)
EndFunc   ;==>_NewArraySort